// +----------------------------------------------------------------------+
// |                              NOMUS.v.1.2                             |
// |                           ELMUCON "  2012                          |
// |                   (Electronic Multi Configurators ")                |
// |            : TarasBY ICQ - 328949732 Skype - TarasBY         |             
// +----------------------------------------------------------------------+
#property copyright "Copyright  2012  by  ELMUCON "
#property link      "elmucon@mail.ru"
// +----------------------------------------------------------------------+ 
//   +------------------------------------------------------------------+
//   |                            USE VARIABLE                          |
//   +------------------------------------------------------------------+
// +----------------------------------------------------------------------+ 
extern string EXPERT          = "===== NOMUS =====";
extern string TIME            = "  ";
extern double   OpenSession           = 2.45;  // ,      ( : . :   0.01  23.59)
extern double   CloseSession          = 22.45; // ,      ( : . :   0.01  23.59)      
extern string MACD_MA         = "  ";
extern string __1__ = "<<<<<<<   Moving >>>>>>>";
  extern bool UseMoving         = TRUE;  //   Moving
   extern int Moving_TF         = 5;    //  
   extern int Moving_Period     = 21;    //  
extern string __2__ = "<<<<<<<<<   CCI >>>>>>>>"; 
  extern bool UseCCI            = TRUE;  //   CCI
   extern int CCI_TF            = 15;    //  
   extern int CCI_Period        = 21;    //   
extern int      MACD_MA_TF            = 60;     //     MACD 
extern double   MACDFastEmaPeriod     = 12;     // MACD           : m1/m5 - 7  : m15/m30 - 14 : h1 - 12
extern double   MACDSlowEmaPeriod     = 26;    // MACD         : m1/m5 - 19 : m15/m30 - 23 : h1 - 26
extern double   MACDSignalPeriod      = 9;     // MACD                    : m1/m5 - 7  : m15/m30 - 8  : h1 - 9
extern double   MACDOpenLevel         = 1;
extern double   Perekos               = 5;
extern string TRADELEVEL      = "  "; 
extern bool     UseBuy                = TRUE;  //  
extern bool     UseSell               = TRUE;  // 
extern bool     UseVirtualTradeLevel  = TRUE;  //    
extern double   TakeProfit            = 0;     //  = 0,  
extern double   StopLoss              = 50;    //  = 0,  
extern double   Trailing              = 10;     //  = 0,  
extern double   MinLot                = 0;     //  = 0,  
extern double   MaxLot                = 0;     //  = 0,  
extern double   Risk                  = 20;    //      .    1%  100%  
extern string CONTROLSPREAD   = "  "; 
extern double   MaxSpread             = 0;     //  = 0,  
extern int      ControlSpreadBuffer   = 0;     //       ( 1000)  = 0, 
extern string MULTIURRENCY   = "   "; 
extern bool     UseMultiCurrencyClose = FALSE;  //       
extern double   MultiCurrencyProfit   = 20;     //      10        ( 5  0,5% )
extern string ADDITION        = " ";
extern bool     ShowVirtualTradeLevel = TRUE;  //       
extern bool     ShowComment           = TRUE;  //    
extern bool     ShowStatistik         = TRUE;  //    
extern bool     UseSymbolStatistik    = TRUE;  //       
extern bool     UseSound              = TRUE;  //   
extern int      SleepPage             = 3;     // 
extern int      MagicNumber           = 0;     //   ( = 0    )
// +----------------------------------------------------------------------+
//   +------------------------------------------------------------------+
//   |                          STATIC VARIABLE                         |
//   +------------------------------------------------------------------+
// +----------------------------------------------------------------------+  
//------- :   
static int BuffSpreads[1000];
   bool    Sesion;
   int     error, cnt, a_i = 0, tiket, total,g_Bars,TradeSignal, 
           gi_Digits, gi_Decimal = 1, Lot_Digit, gi_MyOrders;
   double  sl, tp, SymbolProfit, NowSpread, MiddleSpread, M_Symbol, MultiCurrenci, ProfitClose,
           gd_MAXLOT, gd_MINLOT, gd_LOTSTEP, gd_TP, gd_SL, gd_Trail, gd_Point;
   string  l_marker = "NOMUS.v.1.2", gs_Symbol, SymbolComment;
 //------- :    
       double EMA1;
       double EMA2;
       double LWMA1;
       double LWMA2;
       
// +----------------------------------------------------------------------+
//   +------------------------------------------------------------------+
//   |                     INITIALIZATION FUNCTION                      |
//   +------------------------------------------------------------------+
// +----------------------------------------------------------------------+  
int init(){
    Copyright();
    gi_Digits = Digits;
    gs_Symbol = Symbol();
    gd_Point  = Point;
    Lot_Digit = LotDecimal();
    //----   5-  
    if (gi_Digits == 3 || gi_Digits == 5)
    {gi_Decimal = 10;}
    TakeProfit *= gi_Decimal;
    gd_TP = TakeProfit * gd_Point;
    StopLoss *= gi_Decimal;
    gd_SL = StopLoss * gd_Point;
    Trailing *= gi_Decimal;
    gd_Trail = Trailing * gd_Point;
    return (0);}
// +----------------------------------------------------------------------+
//   +------------------------------------------------------------------+
//   |                    DEINITIALIZATION FUNCTION                     |
//   +------------------------------------------------------------------+
// +----------------------------------------------------------------------+
//------- :      
int deinit(){
    Comment ("");
    string ls_Name;
    for (int li_NUM = 1; li_NUM < 23; li_NUM++)
    {
        ls_Name = StringConcatenate (l_marker, li_NUM);
        if (ObjectFind (ls_Name) != -1)
        {ObjectDelete (ls_Name);}
    }
    return (0);}
// +----------------------------------------------------------------------+
//   +------------------------------------------------------------------+
//   |                        EXSPERT START                             |
//   +------------------------------------------------------------------+
// +----------------------------------------------------------------------+
int start(){
// +----------------------------------------------------------------------+
//------- :    
    if (IsTesting() || IsOptimization())
       {
       iCustom (Symbol(), NULL, "NOMUS.v.1_Symbol", 0, 0);
       MultiCurrenci = 0;
       M_Symbol = GlobalVariableGet (Symbol()+"SymbolMetrs");
       SymbolComment = Symbol();
       }  
    else
       {
       MultiCurrenci = 0;
       M_Symbol      = GlobalVariableGet (Symbol()+"SymbolMetrs");
       double M_USD  = GlobalVariableGet (Symbol()+"MultiMetrUSD"),
              M_EUR  = GlobalVariableGet (Symbol()+"MultiMetrEUR"),
              M_GBP  = GlobalVariableGet (Symbol()+"MultiMetrGBP"),
              M_AUD  = GlobalVariableGet (Symbol()+"MultiMetrAUD"),
              M_CHF  = GlobalVariableGet (Symbol()+"MultiMetrCHF"),
              M_CAD  = GlobalVariableGet (Symbol()+"MultiMetrCAD"),
              M_JPY  = GlobalVariableGet (Symbol()+"MultiMetrJPY");
        if (Symbol() == "EURUSD"){SymbolComment = "EURUSD";
           if      (M_EUR > M_USD){if (M_EUR - M_USD > Perekos) {MultiCurrenci = 1;}}
           else if (M_USD > M_EUR){if (M_USD - M_EUR > Perekos) {MultiCurrenci = -1;}}}
        if (Symbol() == "EURGBP"){SymbolComment = "EURGBP";
           if      (M_EUR > M_GBP){if (M_EUR - M_GBP > Perekos) {MultiCurrenci = 1;}}
           else if (M_GBP > M_EUR){if (M_GBP - M_EUR > Perekos) {MultiCurrenci = -1;}}}
        if (Symbol() == "EURJPY"){SymbolComment = "EURJPY";
           if      (M_EUR > M_JPY){if (M_EUR - M_JPY > Perekos) {MultiCurrenci = 1;}}
           else if (M_JPY > M_EUR){if (M_JPY - M_EUR > Perekos) {MultiCurrenci = -1;}}}
        if (Symbol() == "EURCHF"){SymbolComment = "EURCHF";
           if      (M_EUR > M_CHF){if (M_EUR - M_CHF > Perekos) {MultiCurrenci = 1;}}
           else if (M_CHF > M_EUR){if (M_CHF - M_EUR > Perekos) {MultiCurrenci = -1;}}}
        if (Symbol() == "EURAUD"){SymbolComment = "EURAUD";
           if      (M_EUR > M_AUD){if (M_EUR - M_AUD > Perekos) {MultiCurrenci = 1;}}
           else if (M_AUD > M_EUR){if (M_AUD - M_EUR > Perekos) {MultiCurrenci = -1;}}}
        if (Symbol() == "GBPUSD"){SymbolComment = "GBPUSD";
           if      (M_GBP > M_USD){if (M_GBP - M_USD > Perekos) {MultiCurrenci = 1;}}
           else if (M_USD > M_GBP){if (M_USD - M_GBP > Perekos) {MultiCurrenci = -1;}}}
        if (Symbol() == "GBPCHF"){SymbolComment = "GBPCHF";
           if      (M_GBP > M_CHF){if (M_GBP - M_CHF > Perekos) {MultiCurrenci = 1;}}
           else if (M_CHF > M_GBP){if (M_CHF - M_GBP > Perekos) {MultiCurrenci = -1;}}}
        if (Symbol() == "GBPJPY"){SymbolComment = "GBPJPY";
           if      (M_GBP > M_JPY){if (M_GBP - M_JPY > Perekos) {MultiCurrenci = 1;}}
           else if (M_JPY > M_GBP){if (M_JPY - M_GBP > Perekos) {MultiCurrenci = -1;}}}
        if (Symbol() == "AUDUSD"){SymbolComment = "AUDUSD";
           if      (M_AUD > M_USD){if (M_AUD - M_USD > Perekos) {MultiCurrenci = 1;}}
           else if (M_USD > M_AUD){if (M_USD - M_AUD > Perekos) {MultiCurrenci = -1;}}}
        if (Symbol() == "USDCHF"){SymbolComment = "USDCHF";
           if      (M_CHF > M_USD){if (M_CHF - M_USD > Perekos) {MultiCurrenci = -1;}}
           else if (M_USD > M_CHF){if (M_USD - M_CHF > Perekos) {MultiCurrenci = 1;}}}
        if (Symbol() == "USDJPY"){SymbolComment = "USDJPY";
           if      (M_JPY > M_USD){if (M_JPY - M_USD > Perekos) {MultiCurrenci = -1;}}
           else if (M_USD > M_JPY){if (M_USD - M_JPY > Perekos) {MultiCurrenci = 1;}}}
        if (Symbol() == "USDCAD"){SymbolComment = "USDCAD";
           if      (M_CAD > M_USD){if (M_CAD - M_USD > Perekos) {MultiCurrenci = -1;}}
           else if (M_USD > M_CAD){if (M_USD - M_CAD > Perekos) {MultiCurrenci = 1;}}}
       }
// +----------------------------------------------------------------------+
//------- :   Macd  Ma 
//------- : 
   if(UseMoving)
     {
     bool   Muving_Sell=FALSE,  Muving_Buy=FALSE;
     EMA1 =iMA(NULL,Moving_TF,Moving_Period,0,MODE_EMA,PRICE_CLOSE,0);
     EMA2 =iMA(NULL,Moving_TF,Moving_Period,0,MODE_EMA,PRICE_CLOSE,1);
     LWMA1=iMA(NULL,Moving_TF,Moving_Period,0,MODE_LWMA,PRICE_CLOSE,0);
     LWMA2=iMA(NULL,Moving_TF,Moving_Period,0,MODE_LWMA,PRICE_CLOSE,1);
     Muving_Buy  = LWMA1 > EMA1 && LWMA1 > LWMA2 && EMA1 > EMA2;
     Muving_Sell = LWMA1 < EMA1 && LWMA1 < LWMA2 && EMA1 < EMA2;
     }
     else 
     {
     Muving_Buy  = TRUE;
     Muving_Sell = TRUE;
     }
//------- : CCI
   if(UseCCI)
     {
     bool CCI_Sell = FALSE;
     bool CCI_Buy  = FALSE;
     double CCI_0 = iCCI(NULL,CCI_TF,CCI_Period,PRICE_TYPICAL,0);
     if(CCI_0 > 0){CCI_Buy  = TRUE;}
     if(CCI_0 < 0){CCI_Sell = TRUE;}
     }
     else
     {
     CCI_Buy  = TRUE;
     CCI_Sell = TRUE;
     }
//------- :  MACDOpenLevel
   bool   MacdSell=FALSE,  MacdBuy=FALSE;
   double MacdCurrent    = iMACD(NULL,MACD_MA_TF,MACDFastEmaPeriod,MACDSlowEmaPeriod,MACDSignalPeriod,PRICE_CLOSE,MODE_MAIN,0);
   double MacdPrevious   = iMACD(NULL,MACD_MA_TF,MACDFastEmaPeriod,MACDSlowEmaPeriod,MACDSignalPeriod,PRICE_CLOSE,MODE_MAIN,1);
   double SignalCurrent  = iMACD(NULL,MACD_MA_TF,MACDFastEmaPeriod,MACDSlowEmaPeriod,MACDSignalPeriod,PRICE_CLOSE,MODE_SIGNAL,0);
   if (MacdCurrent < MacdPrevious && MacdCurrent < SignalCurrent && SignalCurrent - MacdCurrent >= MACDOpenLevel*Point){MacdSell = TRUE;}
   if (MacdCurrent > MacdPrevious && MacdCurrent > SignalCurrent && MacdCurrent - SignalCurrent >= MACDOpenLevel*Point){MacdBuy  = TRUE;}
     
   if(Muving_Buy && CCI_Buy && MacdBuy)        {TradeSignal = 1;}
   else{if(Muving_Sell && CCI_Sell && MacdSell){TradeSignal = -1;}
        else                                   {TradeSignal = 0;}}
// +----------------------------------------------------------------------+
//------- :  ,  ,  ,        ,    ,  .
    Sesion = TimeSesion (1);
    gi_MyOrders = TradeSymbol();
    ProfitClose = AccountBalance()/1000*MultiCurrencyProfit;
    bool lb_CheckSpread = false;
    if (MaxSpread <= 0 || ControlSpreadBuffer <= 0)
       {lb_CheckSpread = true; a_i = ControlSpreadBuffer; NowSpread = 0; MiddleSpread = 0;}
    else
       {NowSpread = CheckSpread();
        MiddleSpread = CheckMiddleSpread();
        lb_CheckSpread = (NowSpread <= MiddleSpread && NowSpread <= MaxSpread && a_i == ControlSpreadBuffer);}
    if (gi_MyOrders > 0)
       {
        if (Trailing > 0) {Tral();}
        if (UseVirtualTradeLevel)  {CheckStopLoss(); CheckTakeProfit();}
        if (ShowVirtualTradeLevel) {ShowVirtualLevel();} else {ObjectDelete ("SlLevel"); ObjectDelete ("TpLevel");}
        if (UseMultiCurrencyClose) {if(AccountProfit() >= ProfitClose && OrdersTotal()> 1)CloseAll();}
       }
    else
       { ObjectDelete ("SlLevel"); ObjectDelete ("TpLevel");}
// +----------------------------------------------------------------------+ 
//------- :  ( )
    if (ShowComment){
        string multicurenscomment, treidcomment, spreadcomment, trandcomment, MultiCurrenciComment, M_SymbolComment;
        if (Sesion){if  (a_i < ControlSpreadBuffer) {treidcomment = "SpreadBuffer not ready";}
                    else{
                         if (UseBuy && UseSell)  treidcomment = "Trade Buy and Sell";
                         if (UseBuy && !UseSell) treidcomment = "Trade only Buy";
                         if (!UseBuy && UseSell) treidcomment = "Trade only Sell";}}
        else {treidcomment = "Session Close";}   
        if   (a_i < ControlSpreadBuffer){spreadcomment = StringConcatenate (" SpreadBuffer  : ", (a_i-ControlSpreadBuffer));}
        else {spreadcomment = StringConcatenate (" MiddleSpread  : ", DoubleToStr (MiddleSpread, 0));}
        if   (TradeSignal == 1) {trandcomment = "Up";}
        else {if (TradeSignal == -1) {trandcomment = "Dn";} else {trandcomment = "No";}}    
        if (SymbolComment == Symbol()){
           if (MultiCurrenci == 1) {MultiCurrenciComment = "Up";}
           else {if (MultiCurrenci == -1) {MultiCurrenciComment = "Dn";} else {MultiCurrenciComment = "No";}}}
                 else{MultiCurrenciComment = "No Use";}
        if (M_Symbol == 1) {M_SymbolComment = "Up";}
        else {if (M_Symbol == -1) {M_SymbolComment = "Dn";} else {M_SymbolComment = "No";}} 
        if(UseMultiCurrencyClose){multicurenscomment = " MultClose       : ON";}else{multicurenscomment = " MultClose       : OFF";}  
        string commentseting = StringConcatenate ("                              Server Time : ", DoubleToStr (TimeSesion (0), 2),
                               "\n                              Session : ", DoubleToStr (OpenSession, 2), " - ", DoubleToStr (CloseSession, 2),
                               "\n                              ", treidcomment,
                               "\n                              Perekos          : ", DoubleToStr (Perekos, 1),
                               "\n                              TakeProfit       : ", DoubleToStr (TakeProfit, 0),
                               "\n                              StopLoss         : ", DoubleToStr (StopLoss, 0),
                               "\n                              Trailing           : ", DoubleToStr (Trailing, 0),
                               "\n                              MinLot            : ", DoubleToStr (MinLot, 2),
                               "\n                              MaxLot           : ", DoubleToStr (MaxLot, 2),
                               "\n                              Risk               : ", DoubleToStr (Risk, 0),
                               "\n                             "+multicurenscomment+
                               "\n                              MultProfit       : "+DoubleToStr(ProfitClose,2)+
                               "\n                              MaxSpread     : ", DoubleToStr (MaxSpread, 0),
                               "\n                             ", spreadcomment,
                               "\n                              NowSpread    : ", DoubleToStr (NowSpread, 0),
                               "\n                              TradeSignal     : ", trandcomment,
                               "\n                              ", Symbol(), "        : ", MultiCurrenciComment,
                               "\n                              Symbol          : ", M_SymbolComment);
                        
        Comment (commentseting);
    } else {Comment ("");}
// +----------------------------------------------------------------------+ 
//------- :  .
   if (ShowStatistik) {DrawStats();}
// +----------------------------------------------------------------------+ 
//------- :   
   if (g_Bars == iBars(NULL,0)) return (0);
       g_Bars =  iBars(NULL,0); 
// +----------------------------------------------------------------------+   
//------- :  
        if (lb_CheckSpread && Sesion && gi_MyOrders == 0)
            { 
            RefreshRates(); 
            double Lot = OptimLot();
            if (Lot > 0)  
               {
                if (UseBuy && TradeSignal == 1)
                   {   
                    if (IsTesting() || IsOptimization() || SymbolComment != Symbol()){MultiCurrenci = 1;}  
                    if (M_Symbol == 1 && MultiCurrenci == 1)
                       {
                        tiket = OrderSend (Symbol(), OP_BUY, Lot, NormalizeDouble (Ask, gi_Digits), SleepPage, 0, 0, l_marker + " Buy " + Symbol(), MagicNumber, 0, Lime);
                        if (tiket < 0)
                           {
                            error = GetLastError();
                            Print ("   BUY #", OrderTicket(), " ", ErrorDescript (error));
                            if (UseSound) PlaySound ("timeout.wav");
                            Sleep (500);
                           }
                        else {if (UseSound) PlaySound ("alert4.wav");}
                       }
                   }  
                if (UseSell && TradeSignal == -1)
                   {
                    if (IsTesting() || IsOptimization() || SymbolComment != Symbol()){MultiCurrenci = -1;} 
                    if (M_Symbol == -1 && MultiCurrenci == -1)
                       {
                        tiket = OrderSend (Symbol(), OP_SELL, Lot, NormalizeDouble (Bid, gi_Digits), SleepPage, 0, 0, l_marker + " Sell " + Symbol(), MagicNumber, 0, Red);
                        if (tiket < 0)
                           {
                            error = GetLastError();
                            Print ("   BUY #", OrderTicket(), " ", ErrorDescript (error));
                            if (UseSound) PlaySound ("timeout.wav");
                            Sleep (500);
                           }
                        else {if (UseSound) PlaySound ("alert4.wav");}
                       }
                   }
               }   
           }
// +----------------------------------------------------------------------+
return (0);}
// +----------------------------------------------------------------------+
//   +------------------------------------------------------------------+
//   |                         EXSPERT STOP                             |
//   +------------------------------------------------------------------+
//   +------------------------------------------------------------------+
//   |                       EXSPERT FUNCTION                           |
//   +------------------------------------------------------------------+
// +----------------------------------------------------------------------+
//------- :    
double TimeSesion (int x_x)
{
    datetime ldt_curTime = TimeCurrent();
    double users_hour   = TimeHour (ldt_curTime),
           users_minute = TimeMinute (ldt_curTime),
           users_time = users_hour + (users_minute / 100);
    if (x_x == 0) {return (users_time);}
    else
    {
        if (OpenSession < CloseSession)
        {if (users_time >= OpenSession && users_time <= CloseSession) {return (1);}}
        else if (OpenSession > CloseSession)
        {if ((users_time >= OpenSession && users_time <= 23.59) || (users_time >= 0 && users_time <= CloseSession)) {return (1);}}
    }
    return (0);
}
// +----------------------------------------------------------------------+
//------- :   
double CheckSpread(){ double Spread_0 = (Ask - Bid) / gd_Point; return (Spread_0); }
// +----------------------------------------------------------------------+
//------- :              ControlSpreadBuffer ( 1000 tik)
double CheckMiddleSpread()
{
    int b_i = 0;
    if (a_i <= ControlSpreadBuffer - 1)
       {BuffSpreads[a_i] = CheckSpread(); a_i++;}
    else
       {
        for (int r = ControlSpreadBuffer; r >= 0; r--)
        {if (r > 0) BuffSpreads[r] = BuffSpreads[r-1];}
        BuffSpreads[0] = CheckSpread(); 
       }
    for (int s = 0; s <= a_i; s++)
    {b_i += BuffSpreads[s];}
    b_i /= a_i;
    return (b_i + 2);
}
//+------------------------------------------------------------------+
//------- : ,     
int LotDecimal(){return (MathCeil (MathAbs (MathLog (MarketInfo (gs_Symbol, MODE_LOTSTEP)) / MathLog (10))));}
//+------------------------------------------------------------------+
//------- :   
double OptimLot(){  
   double ModLot    = 0;
   double l_minlot  = MarketInfo(Symbol(), MODE_MINLOT );
   double l_maxlot  = MarketInfo(Symbol(), MODE_MAXLOT );
   if(MinLot == 0)
     {
     ModLot = NormalizeDouble(AccountFreeMargin()/100*Risk/MarketInfo (Symbol(),MODE_MARGINREQUIRED),Lot_Digit);
     if(AccountFreeMargin() - MarketInfo(Symbol(),MODE_MARGINREQUIRED)*l_minlot <= 0)return(-1);
     if(ModLot < l_minlot)return(-1);
     if(MaxLot == 0 || MaxLot>l_maxlot)
       {
       if(ModLot > l_maxlot)ModLot = l_maxlot;
       return(ModLot);
       }
     else
       {
       if(ModLot > MaxLot)ModLot = MaxLot;
       return(ModLot);
       }
     }
   else
     {
     if(MinLot < l_minlot)return(-2);
     if(AccountFreeMargin() - MarketInfo(Symbol(),MODE_MARGINREQUIRED)*MinLot <= 0)return(-1);
     ModLot = MinLot;
     }
return(ModLot);}
// +----------------------------------------------------------------------+
//------- :       ,       
int TradeSymbol()
{
    int TotalTradeSymbol = 0, SendGo = 0,
    li_total = OrdersTotal() - 1;  
    SymbolProfit = 0;
    for (cnt = li_total; cnt >= 0; cnt--)
    {
        if (OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES))
        {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
            {
                if (OrderType() == OP_BUY)
                {
                    if (StopLoss > 0)
                    {
                        if (Bid < OrderOpenPrice())
                        {sl = NormalizeDouble (OrderOpenPrice() - gd_SL, gi_Digits);}
                    }
                    if (TakeProfit > 0)
                    {tp = NormalizeDouble (OrderOpenPrice() + gd_TP, gi_Digits);}
                }
                if (OrderType() == OP_SELL)
                {
                    if (StopLoss > 0)
                    {
                        if (Ask > OrderOpenPrice())
                        {sl = NormalizeDouble(OrderOpenPrice() + gd_SL, gi_Digits);}
                    }
                    if (TakeProfit > 0)
                    {tp = NormalizeDouble (OrderOpenPrice() - gd_TP, gi_Digits);} 
                }
                if (OrderStopLoss() != sl) {SendGo++;}
                if (OrderTakeProfit() != tp) {SendGo++;}
                if (!UseVirtualTradeLevel && SendGo != 0) {OrderModify (OrderTicket(), OrderOpenPrice(), sl, tp, 0, CLR_NONE);}
                TotalTradeSymbol++;
                SymbolProfit += (OrderCommission() + OrderProfit() + OrderSwap());
            }
        }
    }
    return (TotalTradeSymbol);
}
// +----------------------------------------------------------------------+
//------- :   
void CheckStopLoss()
{
    if (sl == 0) return;
    int li_total = OrdersTotal() - 1;  
    double OpenPric = 0;
    for (cnt = li_total; cnt >= 0; cnt--)
    {
        if (OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES))
        {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
            {
                if (OrderType() == OP_BUY)
                {   OpenPric = OrderOpenPrice();
                    if (Bid < sl && Bid < OpenPric && M_Symbol <= 0)
                    {
                     OrderClose (OrderTicket(), OrderLots(), NormalizeDouble (Bid, gi_Digits), SleepPage, Blue); {if (UseSound) PlaySound ("ok.wav");}
                    }
                    if (Bid < sl && Bid > OpenPric)
                    {
                     OrderClose (OrderTicket(), OrderLots(), NormalizeDouble (Bid, gi_Digits), SleepPage, Blue); {if (UseSound) PlaySound ("ok.wav");}
                    }
                }
                if (OrderType() == OP_SELL)
                {   OpenPric = OrderOpenPrice();
                    if (Ask > sl && Ask > OpenPric && M_Symbol >= 0)
                    {
                     OrderClose (OrderTicket(), OrderLots(), NormalizeDouble (Ask, gi_Digits), SleepPage, Blue); {if (UseSound) PlaySound ("ok.wav");}
                    }
                    if (Ask > sl && Ask < OpenPric)
                    {
                     OrderClose (OrderTicket(), OrderLots(), NormalizeDouble (Ask, gi_Digits), SleepPage, Blue); {if (UseSound) PlaySound ("ok.wav");}
                    }
                }
            }
        }
    }
}
// +----------------------------------------------------------------------+
//------- :   
void CheckTakeProfit()
{
    if (tp == 0) return;
    int li_total = OrdersTotal() - 1;  
    for (cnt = li_total; cnt >= 0; cnt--)
    {
        if (OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES))
        {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
            {
                if (OrderType() == OP_BUY)
                {
                    if (Bid > tp)
                    {
                     OrderClose (OrderTicket(), OrderLots(), NormalizeDouble (Bid, gi_Digits), SleepPage, Lime); {if (UseSound) PlaySound ("ok.wav");}
                    }
                }
                if (OrderType() == OP_SELL)
                {
                    if (Ask < tp)
                    {
                     OrderClose (OrderTicket(), OrderLots(), NormalizeDouble (Ask, gi_Digits), SleepPage, Lime); {if (UseSound) PlaySound ("ok.wav");}
                    }
                }
            }
        }
    }
}
// +----------------------------------------------------------------------+
//------- :  
void Tral()
    {
    if (Trailing == 0) return;
    int    li_total = OrdersTotal() - 1;
    double ld_NewSL;
    for (cnt = li_total; cnt >= 0; cnt--)
        {
        if (OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES))
           {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
               {
                if (OrderType() == OP_BUY)  
                   {
                    if (NormalizeDouble (Bid - OrderOpenPrice(), gi_Digits) > gd_Trail)
                       {
                        ld_NewSL = NormalizeDouble (Bid - gd_Trail, gi_Digits);
                        if (sl == 0.0 || sl < ld_NewSL)
                           {
                           sl = ld_NewSL;
                           if (!UseVirtualTradeLevel){ OrderModify (OrderTicket(), OrderOpenPrice(), sl, OrderTakeProfit(), 0, Aqua); }
                           if(UseSound)PlaySound("alert3.wav");
                           }
                       }   
                   }
                if (OrderType() == OP_SELL) 
                   {
                    if (NormalizeDouble (OrderOpenPrice() - Ask, gi_Digits) > gd_Trail)
                       {
                        ld_NewSL = NormalizeDouble (Ask + gd_Trail, gi_Digits);
                        if (sl == 0 || sl > ld_NewSL)
                           {
                            sl = ld_NewSL;
                            if (!UseVirtualTradeLevel){ OrderModify (OrderTicket(), OrderOpenPrice(), sl, OrderTakeProfit(), 0, Aqua); }
                            if(UseSound)PlaySound("alert3.wav");
                           }
                       }
                   }
               }
           }
        }
    }
// +----------------------------------------------------------------------+
//------- :    
void CloseAll(){
if(UseSound)PlaySound("alert.wav");
total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();
    bool result = false;
    switch(type)
    {
      case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), SleepPage, Red ); break;
      case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), SleepPage, Red ); break;
      case OP_BUYLIMIT  :
      case OP_BUYSTOP   :
      case OP_SELLLIMIT :
      case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
    }
    if(result == false)
    {
    error=GetLastError();
    Print("   " +OrderSymbol()+" # "+OrderTicket()+ " - " + ErrorDescript(error));
    }  
  }
}
// +----------------------------------------------------------------------+
//------- :    (    )
void Copyright()
{
string Copyright_1 = "NOMUS  by  ELMUCON  ";
ObjectCreate("Copyright_1", OBJ_LABEL, 0, 0, 0);
ObjectSet("Copyright_1", OBJPROP_CORNER, 2);
ObjectSet("Copyright_1", OBJPROP_XDISTANCE, 110);
ObjectSet("Copyright_1", OBJPROP_YDISTANCE, 20);
ObjectSetText("Copyright_1", Copyright_1 , 9, "Tahoma Narrow", DarkGray); 
string Copyright_2 = "Copyright  2012 ";
ObjectCreate("Copyright_2", OBJ_LABEL, 0, 0, 0);
ObjectSet("Copyright_2", OBJPROP_CORNER, 2);
ObjectSet("Copyright_2", OBJPROP_XDISTANCE, 135);
ObjectSet("Copyright_2", OBJPROP_YDISTANCE, 5);
ObjectSetText("Copyright_2", Copyright_2 , 9, "Tahoma Narrow", DarkGray); } 
// +----------------------------------------------------------------------+
//------- :     (    )
void ShowVirtualLevel(){
ObjectCreate("SlLevel", OBJ_HLINE, 0, 0, 0);
   ObjectSet("SlLevel", OBJPROP_PRICE1, sl);
   ObjectSet("SlLevel", OBJPROP_COLOR, Red);
ObjectCreate("TpLevel", OBJ_HLINE, 0, 0, 0);
   ObjectSet("TpLevel", OBJPROP_PRICE1, tp);
   ObjectSet("TpLevel", OBJPROP_COLOR, Lime);}
// +----------------------------------------------------------------------+
//------- :    ()    (    )
double GetProfitForDay(int ai_0){double l_total = 0;
for (int l_pos =0;l_pos<OrdersHistoryTotal();l_pos++) 
    {if(!(OrderSelect(l_pos,SELECT_BY_POS,MODE_HISTORY)))break;
     if(UseSymbolStatistik)
       {if(OrderSymbol()==Symbol()){if(OrderCloseTime()>=iTime(Symbol(),PERIOD_D1, ai_0)&&OrderCloseTime()<iTime(Symbol(),PERIOD_D1, ai_0)+86400)
          {l_total=l_total+OrderProfit()+OrderCommission()+OrderSwap();}}}
    else
       {if(OrderCloseTime()>=iTime(Symbol(),PERIOD_D1,ai_0)&&OrderCloseTime()<iTime(Symbol(),PERIOD_D1,ai_0)+86400)
          {l_total=l_total+OrderProfit()+OrderCommission()+OrderSwap();}}}return(l_total);}
// +----------------------------------------------------------------------+
//------- :    (    )
void DrawStats() {
//..... :       X  Y    
int Xdist,Ydist; if(ShowComment){Xdist = 200; Ydist = -50;}else{Xdist = 92; Ydist = -50;}
//.....
string l_name;
l_name = l_marker + "1";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 70+Ydist);
ObjectSetText(l_name, "TradeLot ........", 14, "Arial", White);
l_name = l_marker + "2";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 70+Ydist);
ObjectSetText(l_name, DoubleToStr(OptimLot(), 2), 14, "Arial", Gold);
if(OptimLot() == -1)ObjectSetText(l_name, "no many", 14, "Arial", Red);
if(OptimLot() == -2)ObjectSetText(l_name, "error MinLot", 14, "Arial", Red);
if(OptimLot() == -3)ObjectSetText(l_name, "error MaxLot", 14, "Arial", Red);
if(OptimLot() >   0)
  {if(a_i != ControlSpreadBuffer){ObjectSetText(l_name, DoubleToStr(OptimLot(), 2), 14, "Arial", DimGray);}
  else{if(NowSpread <= MiddleSpread && NowSpread <= MaxSpread){
      if(TradeSignal == 1){ObjectSetText(l_name, DoubleToStr(OptimLot(), 2), 14, "Arial", Lime);}
      else{if(TradeSignal == -1){ObjectSetText(l_name, DoubleToStr(OptimLot(), 2), 14, "Arial", Red);}
        else{ObjectSetText(l_name, DoubleToStr(OptimLot(), 2), 14, "Arial", DodgerBlue);}}}   
    if(NowSpread  > MiddleSpread || NowSpread  > MaxSpread){ObjectSetText(l_name, DoubleToStr(OptimLot(), 2), 14, "Arial", Gold);}}}
double ld_0 = GetProfitForDay(0);
l_name = l_marker + "3";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 90+Ydist);
ObjectSetText(l_name, " ........", 14, "Arial", White);
l_name = l_marker + "4";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 90+Ydist);
if(ld_0> 0)ObjectSetText(l_name, DoubleToStr(ld_0, 2), 14, "Arial", Lime);
if(ld_0< 0)ObjectSetText(l_name, DoubleToStr(ld_0, 2), 14, "Arial", Red );
if(ld_0==0)ObjectSetText(l_name, DoubleToStr(ld_0, 2), 14, "Arial", Gold);
ld_0 = GetProfitForDay(1);
l_name = l_marker + "5";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 110+Ydist);
ObjectSetText(l_name, " ............", 14, "Arial", White);
l_name = l_marker + "6";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 110+Ydist);
if(ld_0> 0)ObjectSetText(l_name, DoubleToStr(ld_0, 2), 14, "Arial", Lime);
if(ld_0< 0)ObjectSetText(l_name, DoubleToStr(ld_0, 2), 14, "Arial", Red );
if(ld_0==0)ObjectSetText(l_name, DoubleToStr(ld_0, 2), 14, "Arial", Gold);
ld_0 = GetProfitForDay(2);
l_name = l_marker + "7";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 130+Ydist);
ObjectSetText(l_name, " ....", 14, "Arial", White);
l_name = l_marker + "8";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 130+Ydist);
if(ld_0> 0)ObjectSetText(l_name, DoubleToStr(ld_0, 2), 14, "Arial", Lime);
if(ld_0< 0)ObjectSetText(l_name, DoubleToStr(ld_0, 2), 14, "Arial", Red );
if(ld_0==0)ObjectSetText(l_name, DoubleToStr(ld_0, 2), 14, "Arial", Gold);
l_name = l_marker + "9";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 150+Ydist);
ObjectSetText(l_name, " ..........", 14, "Arial", White);
l_name = l_marker + "10";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 150+Ydist);
if(AccountCredit()> 0)ObjectSetText(l_name, DoubleToStr(AccountCredit(), 2), 14, "Arial", Lime);
if(AccountCredit()< 0)ObjectSetText(l_name, DoubleToStr(AccountCredit(), 2), 14, "Arial", Red );
if(AccountCredit()==0)ObjectSetText(l_name, DoubleToStr(AccountCredit(), 2), 14, "Arial", Gold);
l_name = l_marker + "11";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 170+Ydist);
ObjectSetText(l_name, " ..........", 14, "Arial", White);
l_name = l_marker + "12";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 170+Ydist);
if(AccountBalance()> 0)ObjectSetText(l_name, DoubleToStr(AccountBalance(), 2), 14, "Arial", Lime);
if(AccountBalance()< 0)ObjectSetText(l_name, DoubleToStr(AccountBalance(), 2), 14, "Arial", Red );
if(AccountBalance()==0)ObjectSetText(l_name, DoubleToStr(AccountBalance(), 2), 14, "Arial", Gold);
l_name = l_marker + "13";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 190+Ydist);
ObjectSetText(l_name, " ......", 14, "Arial", White);
l_name = l_marker + "14";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 190+Ydist);
if(AccountEquity()> AccountBalance())ObjectSetText(l_name, DoubleToStr(AccountEquity(), 2), 14, "Arial", Lime);
if(AccountEquity()< AccountBalance())ObjectSetText(l_name, DoubleToStr(AccountEquity(), 2), 14, "Arial", Red );
if(AccountEquity()==AccountBalance())ObjectSetText(l_name, DoubleToStr(AccountEquity(), 2), 14, "Arial", Gold);
l_name = l_marker + "15";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 210+Ydist);
ObjectSetText(l_name, " .....", 14, "Arial", White);
l_name = l_marker + "16";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 210+Ydist);
if(AccountFreeMargin()> AccountBalance())ObjectSetText(l_name, DoubleToStr(AccountFreeMargin(), 2), 14, "Arial", Lime);
if(AccountFreeMargin()< AccountBalance())ObjectSetText(l_name, DoubleToStr(AccountFreeMargin(), 2), 14, "Arial", Red );
if(AccountFreeMargin()==AccountBalance())ObjectSetText(l_name, DoubleToStr(AccountFreeMargin(), 2), 14, "Arial", Gold);
l_name = l_marker + "17";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 230+Ydist);
ObjectSetText(l_name, " ............", 14, "Arial", White);
l_name = l_marker + "18";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0); 
ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 230+Ydist);
if(AccountMargin()> 0)ObjectSetText(l_name,"-"+DoubleToStr(AccountMargin(), 2), 14, "Arial", Red );
if(AccountMargin()==0)ObjectSetText(l_name, DoubleToStr(AccountMargin(), 2), 14, "Arial", Gold);
l_name = l_marker + "19";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 250+Ydist);
ObjectSetText(l_name, " .........", 14, "Arial", White);
l_name = l_marker + "20";
ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
ObjectSet(l_name, OBJPROP_CORNER, 0);
ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
ObjectSet(l_name, OBJPROP_YDISTANCE, 250+Ydist);
if(UseSymbolStatistik){
   if(SymbolProfit> 0)ObjectSetText(l_name, DoubleToStr(SymbolProfit, 2), 14, "Arial", Lime);
   if(SymbolProfit< 0)ObjectSetText(l_name, DoubleToStr(SymbolProfit, 2), 14, "Arial", Red );
   if(SymbolProfit==0)ObjectSetText(l_name, DoubleToStr(SymbolProfit, 2), 14, "Arial", Gold);
   l_name = l_marker + "21";
   ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
   ObjectSet(l_name, OBJPROP_CORNER, 0);
   ObjectSet(l_name, OBJPROP_XDISTANCE, Xdist);
   ObjectSet(l_name, OBJPROP_YDISTANCE, 270+Ydist);
   ObjectSetText(l_name, " ..........", 14, "Arial", White);
   l_name = l_marker + "22";
   ObjectCreate(l_name, OBJ_LABEL, 0, 0, 0);
   ObjectSet(l_name, OBJPROP_CORNER, 0);
   ObjectSet(l_name, OBJPROP_XDISTANCE, 120+Xdist);
   ObjectSet(l_name, OBJPROP_YDISTANCE, 270+Ydist);
   if(AccountProfit()> 0)ObjectSetText(l_name, DoubleToStr(AccountProfit(), 2), 14, "Arial", Lime);
   if(AccountProfit()< 0)ObjectSetText(l_name, DoubleToStr(AccountProfit(), 2), 14, "Arial", Red );
   if(AccountProfit()==0)ObjectSetText(l_name, DoubleToStr(AccountProfit(), 2), 14, "Arial", Gold);}
else{
  ObjectDelete(l_marker + "21");  ObjectDelete(l_marker + "22"); 
  if(AccountProfit()> 0)ObjectSetText(l_name, DoubleToStr(AccountProfit(), 2), 14, "Arial", Lime);
  if(AccountProfit()< 0)ObjectSetText(l_name, DoubleToStr(AccountProfit(), 2), 14, "Arial", Red );
  if(AccountProfit()==0)ObjectSetText(l_name, DoubleToStr(AccountProfit(), 2), 14, "Arial", Gold);}
}
// +----------------------------------------------------------------------+ 
string ErrorDescript(int error_code){string error_string;switch(error_code){
//----  ,   :
      case 0:   error_string=" ";                                                                                             break;
      case 1:   error_string=" ,   ";                                                                    break;
      case 2:   error_string=" ";                                                                                           break;
      case 3:   error_string=" ";                                                                                 break;
      case 4:   error_string="  ";                                                                                  break;
      case 5:   error_string="   ";                                                                    break;
      case 6:   error_string="    ";                                                                          break;
      case 7:   error_string=" ";                                                                                      break;
      case 8:   error_string="  ";                                                                                 break;
      case 9:   error_string="    ";                                              break;
      case 64:  error_string=" ";                                                                                      break;
      case 65:  error_string="  ";                                                                               break;
      case 128: error_string="    ";                                                                  break;
      case 129: error_string=" ";                                                                                      break;
      case 130: error_string=" ";                                                                                     break;
      case 131: error_string=" ";                                                                                     break;
      case 132: error_string=" ";                                                                                           break;
      case 133: error_string=" ";                                                                                     break;  
      case 134: error_string="    ";                                                             break;
      case 135: error_string=" ";                                                                                        break;
      case 136: error_string=" ";                                                                                                break;
      case 137: error_string=" ";                                                                                           break;
      case 138: error_string=" ";                                                                                             break;
      case 139: error_string="    ";                                                                break;
      case 140: error_string="  ";                                                                               break;
      case 141: error_string="  ";                                                                                 break;
      case 145: error_string=" ,       ";                                            break;
      case 146: error_string="  ";                                                                             break;
      case 147: error_string="     ";                                                 break;
      case 148: error_string="      ,  .";                    break;
//----    MQL4-:
      case 4000: error_string=" ";                                                                                            break;
      case 4001: error_string="  ";                                                                        break;
      case 4002: error_string="  -  ";                                                                        break;
      case 4003: error_string="    ";                                                                          break;
      case 4004: error_string="    ";                                                          break;
      case 4005: error_string="      ";                                                           break;
      case 4006: error_string="    ";                                                                   break;
      case 4007: error_string="    ";                                                                       break;
      case 4008: error_string=" ";                                                                           break;
      case 4009: error_string="   ";                                                                 break;
      case 4010: error_string="    ";                                                                     break;
      case 4011: error_string="  ";                                                                                break;
      case 4012: error_string="    ";                                                                            break;
      case 4013: error_string="  ";                                                                                       break;
      case 4014: error_string=" ";                                                                                   break;
      case 4015: error_string=" ";                                                                                  break;
      case 4016: error_string=" ";                                                                           break;
      case 4017: error_string=" DLL  ";                                                                               break;
      case 4018: error_string="  ";                                                                       break;
      case 4019: error_string="  ";                                                                            break;
      case 4020: error_string="     ";                                                      break;
      case 4021: error_string="   ,   ";                                               break;
      case 4022: error_string=" ";                                                                                        break;
      case 4050: error_string="   ";                                                            break;
      case 4051: error_string="   ";                                                               break;
      case 4052: error_string="   ";                                                                   break;
      case 4053: error_string=" ";                                                                                        break;
      case 4054: error_string="  -";                                                          break;
      case 4055: error_string="  ";                                                                   break;
      case 4056: error_string=" ";                                                                                  break;
      case 4057: error_string="   ";                                                               break;
      case 4058: error_string="   ";                                                                   break;
      case 4059: error_string="     ";                                                                break;
      case 4060: error_string="  ";                                                                                  break;
      case 4061: error_string="  ";                                                                                 break;
      case 4062: error_string="   string";                                                                        break;
      case 4063: error_string="   integer";                                                                       break;
      case 4064: error_string="   double";                                                                        break;
      case 4065: error_string="    ";                                                                 break;
      case 4066: error_string="     ";                                                break;
      case 4067: error_string="    ";                                                               break;
      case 4099: error_string=" ";                                                                                           break;
      case 4100: error_string="    ";                                                                            break;
      case 4101: error_string="  ";                                                                                break;
      case 4102: error_string="   ";                                                                         break;
      case 4103: error_string="  ";                                                                               break;
      case 4104: error_string="    ";                                                                   break;
      case 4105: error_string="    ";                                                                               break;
      case 4106: error_string=" ";                                                                                    break;
      case 4107: error_string="     ";                                                       break;
      case 4108: error_string="  ";                                                                                 break;
      case 4109: error_string="  .         .";  break;
      case 4110: error_string="   .    .";                                 break;
      case 4111: error_string="   .    .";                                break;
      case 4200: error_string="  ";                                                                                 break;
      case 4201: error_string="   ";                                                                break;
      case 4202: error_string="  ";                                                                                  break;
      case 4203: error_string="  ";                                                                               break;
      case 4204: error_string="  ";                                                                                     break;
      case 4205: error_string="  ";                                                                              break;
      case 4206: error_string="   ";                                                                          break;
      default:   error_string="    ";}
return(error_string);}
// +----------------------------------------------------------------------+
//   +------------------------------------------------------------------+
//   |                           END CODE                               |
//   +------------------------------------------------------------------+
// +----------------------------------------------------------------------+


