//+----------------------------------------------------------------------+
//|                         #EMC_Multi_Clock.mq4                         |
//|                    ANALITIK 3 by ELMUCON  2011                      |
//|                   (Electronic Multi Configurator)                    |
//+----------------------------------------------------------------------+
#property copyright "#EMC_Multi_Clock, ANALITIK 3 by ELMUCON  2011"    //
#property link      "elmucon@mail.ru"                                   //
//======================================================================//
#property indicator_chart_window                                        //
#property indicator_buffers 1                                           //
#property indicator_color1 Red                                          //
#import "kernel32.dll"                                                  //
   void GetLocalTime(int& a0[]);                                        //                            
   int GetTimeZoneInformation(int& a0[]);                               //
//======================================================================//
 extern bool ShowLocal          = FALSE;                                //
extern color Color_Local_Label  = White;                                //
extern color Color_Local_Clock  = White;                                //
 extern bool ShowBar            = TRUE;                                 //
extern color Color_Bar_Label    = White;                                //
extern color Color_Bar_Clock    = White;                                //
 extern bool Show12HourTime     = FALSE;                                //
extern color Color_Time_Label   = Gray;                                 //
extern color Color_Time_Clock         = Gray;                           //
  extern int Open_Sesion        = 8;                                    //
  extern int Close_Sesion       = 17;                                   //
extern color Color_Sesion_Label = Aqua;                                 //
extern color Color_Sesion_Clock = Aqua;                                 //
  extern int corner             = 1;                                    //
  extern int topOff             = 210;                                  //
//======================================================================//
        int gi_100;                                                     //
     double g_ibuf_104[];                                               //
        int gi_108 = 0;                                                 //
        int gi_112 = 9;                                                 //
        int gi_116 = -5;                                                //
//======================================================================//
string TimeToString(int ai_0) {
   if (!Show12HourTime) return (TimeToStr(ai_0, TIME_MINUTES));
   int li_4 = TimeHour(ai_0);
   int l_minute_8 = TimeMinute(ai_0);
   string ls_12 = " AM";
   if (li_4 >= 12) {
      li_4 -= 12;
      ls_12 = " PM";
   }
   if (li_4 == 0) li_4 = 12;
   string ls_ret_20 = DoubleToStr(li_4, 0) + ":";
   if (l_minute_8 < 10) ls_ret_20 = ls_ret_20 + "0";
   ls_ret_20 = ls_ret_20 + DoubleToStr(l_minute_8, 0);
   ls_ret_20 = ls_ret_20 + ls_12;
   return (ls_ret_20);
}

int start() {
   int lia_0[4];
   int lia_4[43];
   string ls_unused_8;
   if (!IsDllsAllowed()) {
      Alert("FPM Clock: DLLs are disabled.  To enable tick the checkbox in the Common Tab of indicator");
      return;
   }
   int l_ind_counted_16 = IndicatorCounted();
   GetLocalTime(lia_0);
   int li_20 = lia_0[0] & 65535;
   int li_24 = lia_0[0] >> 16;
   int li_28 = lia_0[1] >> 16;
   int li_32 = lia_0[2] & 65535;
   int li_36 = lia_0[2] >> 16;
   int li_40 = lia_0[3] & 65535;
   int li_44 = lia_0[3] >> 16;
   string ls_48 = FormatDateTime(li_20, li_24, li_28, li_32, li_36, li_40);
   int l_str2time_56 = StrToTime(ls_48);
   gi_108 = GMT_Offset("LONDON", l_str2time_56);
   gi_112 = GMT_Offset("TOKYO", l_str2time_56);
   gi_116 = GMT_Offset("US", l_str2time_56);
   int li_60 = 0;
   int li_64 = GetTimeZoneInformation(lia_4);
   if (li_64 != 0) li_60 = lia_4[0];
   if (li_64 == 2) li_60 += lia_4[42];
   int l_datetime_68 = TimeCurrent();
   int li_72 = l_str2time_56 + 60 * li_60;
   int li_76 = li_72 + 3600 * gi_108;
   int li_80 = li_72 + 3600 * gi_112;
   int li_84 = li_72 + 3600 * gi_116;
   string l_text_88 = TimeToString(li_72);
   string l_text_96 = TimeToString(l_str2time_56);
   string l_text_104 = TimeToString(li_76);
   string l_text_112 = TimeToString(li_80);
   string l_text_120 = TimeToString(li_84);
   string l_text_128 = TimeToString(TimeCurrent());
   string l_time2str_136 = TimeToStr(TimeCurrent() - Time[0], TIME_MINUTES);
   if (ShowLocal) {
      ObjectSetText("locl", " ", 12, "Arial", Color_Local_Label);
      ObjectSetText("loct", l_text_96, 12, "Arial", Color_Local_Clock);
   }
   
 int NY_Time = StrToInteger(l_text_120);
 if (NY_Time >= Open_Sesion && NY_Time <= (Close_Sesion-1))
    {ObjectSetText("nyl", " ", 12, "Arial", Color_Sesion_Label);
     ObjectSetText("nyt", l_text_120, 12, "Arial", Color_Sesion_Clock);}
else{ObjectSetText("nyl", " ", 12, "Arial", Color_Time_Label);
     ObjectSetText("nyt", l_text_120, 12, "Arial", Color_Time_Clock);}
   
 int LON_Time = StrToInteger(l_text_104);
 if (LON_Time >= Open_Sesion && LON_Time <= (Close_Sesion-1))   
    {ObjectSetText("lonl", " ", 12, "Arial", Color_Sesion_Label);
     ObjectSetText("lont", l_text_104, 12, "Arial", Color_Sesion_Clock);}
else{ObjectSetText("lonl", " ", 12, "Arial", Color_Time_Label);
     ObjectSetText("lont", l_text_104, 12, "Arial", Color_Time_Clock);}


 int TOK_Time = StrToInteger(l_text_112);
 if (TOK_Time >= Open_Sesion && TOK_Time <= (Close_Sesion-1)) 
    {ObjectSetText("tokl", " ", 12, "Arial", Color_Sesion_Label);
     ObjectSetText("tokt", l_text_112, 12, "Arial", Color_Sesion_Clock);}
else{ObjectSetText("tokl", " ", 12, "Arial", Color_Time_Label);
     ObjectSetText("tokt", l_text_112, 12, "Arial", Color_Time_Clock);}
   
   
    ObjectSetText("barl", " ", 12, "Arial", Color_Bar_Label);
    ObjectSetText("bart", l_time2str_136, 12, "Arial", Color_Bar_Clock);
   
   
   gi_100 = NormalizeDouble((Ask - Bid) / Point, 0);
   return (0);
}

int ObjectMakeLabel(string a_name_0, int a_x_8, int a_y_12) {
   ObjectCreate(a_name_0, OBJ_LABEL, 0, 0, 0);
   ObjectSet(a_name_0, OBJPROP_CORNER, corner);
   ObjectSet(a_name_0, OBJPROP_XDISTANCE, a_x_8);
   ObjectSet(a_name_0, OBJPROP_YDISTANCE, a_y_12);
   ObjectSet(a_name_0, OBJPROP_BACK, TRUE);
   return (0);
}

string FormatDateTime(int ai_0, int ai_4, int ai_8, int ai_12, int ai_16, int ai_20) {
   string ls_24 = ai_4 + 100;
   ls_24 = StringSubstr(ls_24, 1);
   string ls_32 = ai_8 + 100;
   ls_32 = StringSubstr(ls_32, 1);
   string ls_40 = ai_12 + 100;
   ls_40 = StringSubstr(ls_40, 1);
   string ls_48 = ai_16 + 100;
   ls_48 = StringSubstr(ls_48, 1);
   string ls_56 = ai_20 + 100;
   ls_56 = StringSubstr(ls_56, 1);
   return (StringConcatenate(ai_0, ".", ls_24, ".", ls_32, " ", ls_40, ":", ls_48, ":", ls_56));
}

int init() {
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, g_ibuf_104);
   int li_0 = topOff;
   int li_4 = 60;
   if (Show12HourTime) li_4 = 75;
   if (ShowLocal) {
      ObjectMakeLabel("locl", li_4, li_0);
      ObjectMakeLabel("loct", 15, li_0);
   }
   ObjectMakeLabel("nyl",  li_4, li_0 - 16);
   ObjectMakeLabel("nyt",  15, li_0 - 16);
   ObjectMakeLabel("lonl", li_4, li_0 - 32);
   ObjectMakeLabel("lont", 15, li_0 - 32);
   ObjectMakeLabel("tokl", li_4, li_0 - 47);
   ObjectMakeLabel("tokt", 15, li_0 - 47);
   if (ShowBar) {
   ObjectMakeLabel("barl", li_4, li_0 - 62);
   ObjectMakeLabel("bart", 15, li_0 - 62);
   }

   return (0);
}

int deinit() {
   ObjectDelete("locl");
   ObjectDelete("loct");
   ObjectDelete("nyl");
   ObjectDelete("nyt");
   ObjectDelete("lonl");
   ObjectDelete("lont");
   ObjectDelete("tokl");
   ObjectDelete("tokt");
   ObjectDelete("barl");
   ObjectDelete("bart");
   return (0);
}

int GMT_Offset(string as_0, int ai_8) {
   int li_ret_12 = 0;
   if (as_0 == "FRANKFURT") li_ret_12 = GMT1(ai_8);
   else {
      if (as_0 == "LONDON") li_ret_12 = GMT0(ai_8);
      else {
         if (as_0 == "US") li_ret_12 = GMT_5(ai_8);
         else
            if (as_0 == "TOKYO") li_ret_12 = GMT9(ai_8);
      }
   }
   return (li_ret_12);
}

int GMT0(int ai_0) {
   if (ai_0 > last_sunday(TimeYear(ai_0), 3) && ai_0 < last_sunday(TimeYear(ai_0), 10)) return (1);
   return (0);
}

int GMT_5(int ai_0) {
   if (TimeYear(ai_0) < 2007) {
      if (ai_0 > first_sunday(TimeYear(ai_0), 4) && ai_0 < last_sunday(TimeYear(ai_0), 10)) return (-4);
      return (-5);
   }
   if (ai_0 > second_sunday(TimeYear(ai_0), 3) && ai_0 < first_sunday(TimeYear(ai_0), 11)) return (-4);
   return (-5);
}

int GMT9(int ai_unused_0) {
   return (9);
}

bool is_leap_year(int ai_0) {
   if (MathMod(ai_0, 100) == 0.0 && MathMod(ai_0, 400) == 0.0) return (TRUE);
   if (MathMod(ai_0, 100) != 0.0 && MathMod(ai_0, 4) == 0.0) return (TRUE);
   return (FALSE);
}

int n_days(int ai_0, int ai_4) {
   int li_ret_8;
   if (ai_4 == 1) li_ret_8 = 31;
   else {
      if (ai_4 == 2) {
         if (is_leap_year(ai_0)) li_ret_8 = 29;
         else li_ret_8 = 28;
      } else {
         if (ai_4 == 3) li_ret_8 = 31;
         else {
            if (ai_4 == 4) li_ret_8 = 30;
            else {
               if (ai_4 == 5) li_ret_8 = 31;
               else {
                  if (ai_4 == 6) li_ret_8 = 30;
                  else {
                     if (ai_4 == 7) li_ret_8 = 31;
                     else {
                        if (ai_4 == 8) li_ret_8 = 31;
                        else {
                           if (ai_4 == 9) li_ret_8 = 30;
                           else {
                              if (ai_4 == 10) li_ret_8 = 31;
                              else {
                                 if (ai_4 == 11) li_ret_8 = 30;
                                 else
                                    if (ai_4 == 12) li_ret_8 = 31;
                              }
                           }
                        }
                     }
                  }
               }
            }
         }
      }
   }
   return (li_ret_8);
}

int n_sdays(int ai_0, int ai_4) {
   int l_str2time_8;
   int li_12 = n_days(ai_0, ai_4);
   int l_count_16 = 0;
   for (int li_20 = 1; li_20 <= li_12; li_20++) {
      l_str2time_8 = StrToTime(DoubleToStr(ai_0, 0) + "." + DoubleToStr(ai_4, 0) + "." + DoubleToStr(li_20, 0) + " 00:00");
      if (TimeDayOfWeek(l_str2time_8) == 0) l_count_16++;
   }
   return (l_count_16);
}

int last_sunday(int ai_0, int ai_4) {
   int l_str2time_8;
   int l_str2time_12;
   int li_16 = n_days(ai_0, ai_4);
   int li_20 = n_sdays(ai_0, ai_4);
   int l_count_24 = 0;
   for (int li_28 = 1; li_28 <= li_16; li_28++) {
      l_str2time_8 = StrToTime(DoubleToStr(ai_0, 0) + "." + DoubleToStr(ai_4, 0) + "." + DoubleToStr(li_28, 0) + " 00:00");
      if (TimeDayOfWeek(l_str2time_8) == 0) l_count_24++;
      if (l_count_24 == li_20) {
         l_str2time_12 = l_str2time_8;
         break;
      }
   }
   return (l_str2time_12);
}

int first_sunday(int ai_0, int ai_4) {
   int l_str2time_8;
   int l_str2time_12;
   int li_16 = n_days(ai_0, ai_4);
   bool li_20 = TRUE;
   int l_count_24 = 0;
   for (int li_28 = 1; li_28 <= li_16; li_28++) {
      l_str2time_8 = StrToTime(DoubleToStr(ai_0, 0) + "." + DoubleToStr(ai_4, 0) + "." + DoubleToStr(li_28, 0) + " 00:00");
      if (TimeDayOfWeek(l_str2time_8) == 0) l_count_24++;
      if (l_count_24 == li_20) {
         l_str2time_12 = l_str2time_8;
         break;
      }
   }
   return (l_str2time_12);
}

int second_sunday(int ai_0, int ai_4) {
   int l_str2time_8;
   int l_str2time_12;
   int li_16 = n_days(ai_0, ai_4);
   int li_20 = 2;
   int l_count_24 = 0;
   for (int li_28 = 1; li_28 <= li_16; li_28++) {
      l_str2time_8 = StrToTime(DoubleToStr(ai_0, 0) + "." + DoubleToStr(ai_4, 0) + "." + DoubleToStr(li_28, 0) + " 00:00");
      if (TimeDayOfWeek(l_str2time_8) == 0) l_count_24++;
      if (l_count_24 == li_20) {
         l_str2time_12 = l_str2time_8;
         break;
      }
   }
   return (l_str2time_12);
}

int GMT1(int ai_0) {
   if (ai_0 > last_sunday(TimeYear(ai_0), 3) && ai_0 < last_sunday(TimeYear(ai_0), 10)) return (2);
   return (1);
}
//======================================================================//